//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%404CBFA2003B.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%404CBFA2003B.cm

//## begin module%404CBFA2003B.cp preserve=no
//## end module%404CBFA2003B.cp

//## Module: XRTResponse%404CBFA2003B; Package specification
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/MixFunction/XRTResponse.h

#ifndef XRTRESPONSE_H
#define XRTRESPONSE_H 1

//## begin module%404CBFA2003B.additionalIncludes preserve=no
//## end module%404CBFA2003B.additionalIncludes

//## begin module%404CBFA2003B.includes preserve=yes
//## end module%404CBFA2003B.includes

// Error
#include <XSUtil/Error/Error.h>
//## begin module%404CBFA2003B.declarations preserve=no
//## end module%404CBFA2003B.declarations

//## begin module%404CBFA2003B.additionalDeclarations preserve=yes
//## end module%404CBFA2003B.additionalDeclarations


//## begin XRTResponse%404CC13D023A.preface preserve=yes
//## end XRTResponse%404CC13D023A.preface

//## Class: XRTResponse%404CC13D023A
//## Category: XSModel::Model::MixFunction%3F7461FF026E
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class XRTResponse 
{
  //## begin XRTResponse%404CC13D023A.initialDeclarations preserve=yes
  //## end XRTResponse%404CC13D023A.initialDeclarations

  public:
    //## Class: XRTResponseError%404F66C901A4
    //## Category: XSModel::Model::MixFunction%3F7461FF026E
    //## Subsystem: XSModel::Model::MixFunction%3F74624902C0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class XRTResponseError : public YellowAlert  //## Inherits: <unnamed>%404F67000000
    {
      public:
        //## Constructors (specified)
          //## Operation: XRTResponseError%404F67D400EB
          XRTResponseError (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Constructors (specified)
      //## Operation: XRTResponse%404CC1FC004C
      XRTResponse (const string& fileName);

    //## Destructor (generated)
      ~XRTResponse();


    //## Other Operations (specified)
      //## Operation: ebinEffectiveArea%404F860201F8
      Real ebinEffectiveArea (Real eMin, Real eMax, Real theta, Real phi);

  public:
    // Additional Public Declarations
      //## begin XRTResponse%404CC13D023A.public preserve=yes
      //## end XRTResponse%404CC13D023A.public

  protected:
    // Additional Protected Declarations
      //## begin XRTResponse%404CC13D023A.protected preserve=yes
      //## end XRTResponse%404CC13D023A.protected

  private:

    //## Other Operations (specified)
      //## Operation: readEffectiveArea%404F52370360
      void readEffectiveArea ();

      //## Operation: calcEffectiveArea%404F86B900C7
      Real calcEffectiveArea ();

      //## Operation: order%404F881C0160
      void order ();

      //## Operation: getSmoothRsp%4050983E000B
      Real getSmoothRsp (int ie, int iTheta, int iPhi);

      //## Operation: smooth%405098A2030F
      Real smooth (const RealArray& X, const RealArray& Y);

      //## Operation: effAreaInterp%405099800031
      Real effAreaInterp (int ie, int iTheta, int iPhi);

      //## Operation: getWeightTheta%4050A180021F
      Real getWeightTheta (int iTheta);

      //## Operation: getWeightPhi%4050A1BB0174
      Real getWeightPhi (int iPhi);

      //## Operation: weightAverage%4050A1E20266
      Real weightAverage (bool isPhi);

    // Additional Private Declarations
      //## begin XRTResponse%404CC13D023A.private preserve=yes
      //## end XRTResponse%404CC13D023A.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: fileName%404CC1ED01E5
      //## begin XRTResponse::fileName%404CC1ED01E5.attr preserve=no  private: string {U} 
      string m_fileName;
      //## end XRTResponse::fileName%404CC1ED01E5.attr

      //## Attribute: energy%404F52540246
      //## begin XRTResponse::energy%404F52540246.attr preserve=no  private: RealArray {U} 
      RealArray m_energy;
      //## end XRTResponse::energy%404F52540246.attr

      //## Attribute: theta%404F529200B7
      //## begin XRTResponse::theta%404F529200B7.attr preserve=no  private: RealArray {U} 
      RealArray m_theta;
      //## end XRTResponse::theta%404F529200B7.attr

      //## Attribute: phi%404F52AC0250
      //## begin XRTResponse::phi%404F52AC0250.attr preserve=no  private: RealArray {U} 
      RealArray m_phi;
      //## end XRTResponse::phi%404F52AC0250.attr

      //## Attribute: effectiveArea%404F52D203A6
      //## begin XRTResponse::effectiveArea%404F52D203A6.attr preserve=no  private: RealArray {U} 
      RealArray m_effectiveArea;
      //## end XRTResponse::effectiveArea%404F52D203A6.attr

      //## Attribute: colNames%404F68C803DA
      //## begin XRTResponse::colNames%404F68C803DA.attr preserve=no  private: static StringArray {U} 
      static StringArray s_colNames;
      //## end XRTResponse::colNames%404F68C803DA.attr

      //## Attribute: ENERG_LO%404F6A4B007A
      //## begin XRTResponse::ENERG_LO%404F6A4B007A.attr preserve=no  private: static string {U} "ENERG_LO"
      static string s_ENERG_LO;
      //## end XRTResponse::ENERG_LO%404F6A4B007A.attr

      //## Attribute: THETA%404F6C8A02E6
      //## begin XRTResponse::THETA%404F6C8A02E6.attr preserve=no  private: static string {U} "THETA"
      static string s_THETA;
      //## end XRTResponse::THETA%404F6C8A02E6.attr

      //## Attribute: PHI%404F6CC701BA
      //## begin XRTResponse::PHI%404F6CC701BA.attr preserve=no  private: static string {U} "PHI"
      static string s_PHI;
      //## end XRTResponse::PHI%404F6CC701BA.attr

      //## Attribute: EFFAREA%404F6CFE0057
      //## begin XRTResponse::EFFAREA%404F6CFE0057.attr preserve=no  private: static string {U} "EFFAREA"
      static string s_EFFAREA;
      //## end XRTResponse::EFFAREA%404F6CFE0057.attr

      //## Attribute: inEng%404F87B003A7
      //## begin XRTResponse::inEng%404F87B003A7.attr preserve=no  private: Real {U} 
      Real m_inEng;
      //## end XRTResponse::inEng%404F87B003A7.attr

      //## Attribute: eOrder%404F87EF0130
      //## begin XRTResponse::eOrder%404F87EF0130.attr preserve=no  private: IntegerArray {U} 
      IntegerArray m_eOrder;
      //## end XRTResponse::eOrder%404F87EF0130.attr

      //## Attribute: inTheta%404F9DCC0294
      //## begin XRTResponse::inTheta%404F9DCC0294.attr preserve=no  private: Real {U} 
      Real m_inTheta;
      //## end XRTResponse::inTheta%404F9DCC0294.attr

      //## Attribute: inPhi%404F9DDE01FB
      //## begin XRTResponse::inPhi%404F9DDE01FB.attr preserve=no  private: Real {U} 
      Real m_inPhi;
      //## end XRTResponse::inPhi%404F9DDE01FB.attr

      //## Attribute: rspTheta%4050975D037C
      //## begin XRTResponse::rspTheta%4050975D037C.attr preserve=no  private: RealArray {U} 
      RealArray m_rspTheta;
      //## end XRTResponse::rspTheta%4050975D037C.attr

      //## Attribute: rspPhi%405097DC03D6
      //## begin XRTResponse::rspPhi%405097DC03D6.attr preserve=no  private: RealArray {U} 
      RealArray m_rspPhi;
      //## end XRTResponse::rspPhi%405097DC03D6.attr

      //## Attribute: wghtTheta%405097F200AF
      //## begin XRTResponse::wghtTheta%405097F200AF.attr preserve=no  private: RealArray {U} 
      RealArray m_wghtTheta;
      //## end XRTResponse::wghtTheta%405097F200AF.attr

      //## Attribute: wghtPhi%4050981A0156
      //## begin XRTResponse::wghtPhi%4050981A0156.attr preserve=no  private: RealArray {U} 
      RealArray m_wghtPhi;
      //## end XRTResponse::wghtPhi%4050981A0156.attr

    // Additional Implementation Declarations
      //## begin XRTResponse%404CC13D023A.implementation preserve=yes
      //## end XRTResponse%404CC13D023A.implementation

};

//## begin XRTResponse%404CC13D023A.postscript preserve=yes
//## end XRTResponse%404CC13D023A.postscript

// Class XRTResponse::XRTResponseError 

// Class XRTResponse 

//## begin module%404CBFA2003B.epilog preserve=yes
//## end module%404CBFA2003B.epilog


#endif
